<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    /** @use HasFactory<\Database\Factories\UserFactory> */
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var list<string>
     */
    protected $fillable = [
        'user_id',
        'course_id',
        'start_date',
        'payment_method',
        'status',
        'comment',
    ];

    protected function casts(): array
    {
        return [
            'start_date' => 'date',
        ];
    }

    public function user(): belongsTo
    {
        return $this->hasMany(User::class);
    }

    public function course(): belongsTo
    {
        return $this->hasMany(Course::class);
    }

    public function canAddComment(): bool
    {
        return $this->status === "completed" && !$this->comment;
    }
}
